/* $Id: time-o-matic.h,v 1.8 2005/04/05 12:02:55 ellson Exp $ $Revision: 1.8 $ */
/* vim:set shiftwidth=4 ts=8: */
/*
 This software is part of the graphviz package
 Copyright (c) 1995-2004 AT&T Corp.
 Licensed under the Common Public License, Version 1.0 (the "License")
 Any use, reproduction or distribution of this software constitutes
 acceptance of the License.  A copy of the License is available at:
     http://www.research.att.com/sw/license/cpl-1.0.html
 (with md5 checksum 201a9e4ba08a96f5d9677315d8ce1463)
*/

#pragma warning (disable : 4786 4503)
#include <string>
#include <vector>
#include <map>
#include <stdarg.h>

struct Timer {
	double Start();
	double Elapsed(int rt,double start,char *s,...);
	double Now(int rt,char *s,...);

	void LoopPoint(int rt,char *s);
	Timer();
private:
	double currentTime();
	double display(int rt,double last,char *format,char *s,va_list va);
#ifdef _WIN32
	__int64 m_frequency,m_start;
#endif
	double m_last;
	std::vector<double> m_looplasts;
};
extern Timer timer;
