/* $Id: nspvt.h,v 1.3 2004/12/11 19:26:11 ellson Exp $ $Revision: 1.3 $ */
/* vim:set shiftwidth=4 ts=8: */

/**********************************************************
*      This software is part of the graphviz package      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2004 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
**********************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#include <ns.h>

#ifndef uchar
#define uchar unsigned short
#define boolean uchar
#endif

    typedef struct nsnode_s {
	Agrec_t h;
	int n_rank;
	int n_low, n_lim;
	int n_priority;
	Agedge_t *n_par;
	Agedge_t *n_tree[2];
	uchar n_mark, n_dmark, n_onstack;
    } nsnode_t;

    typedef struct nsedge_s {
	Agrec_t h;
	int e_cutval;
	int e_weight;
	int e_minlen;
	Agedge_t *prv[2], *nxt[2];
	uchar e_treeflag;
    } nsedge_t;

    typedef struct nsgraph_s {
	Agrec_t h;
	int g_n_tree_edges;
	int g_n_nodes;
	int g_maxiter;
	Agnode_t *g_finger;
    } nsgraph_t;

#ifdef __cplusplus
}
#endif
